ServerEvents.recipes(e=> {
    //eding
    e.remove({ output: '#forge:ingots/osmium',type:"minecraft:smelting"})
    e.remove({ output: '#forge:ingots/osmium',type:"minecraft:blasting"})

    e.replaceInput({mod:'mekanism'}, 'minecraft:copper_ingot', 'nwtc:alumite_ingot')
    e.replaceInput({mod:'mekanism'}, 'minecraft:iron_ingot', 'nwtc:red_aurum_ingot')
    e.replaceInput({mod:'mekanism'}, 'minecraft:redstone', '#immersiveengineering:circuits/pcb')
    e.replaceInput({mod:'mekanism'}, 'minecraft:glowstone_dust', 'enderio:clayed_glowstone')
    e.replaceInput({mod:'mekanism'}, 'minecraft:diamond', 'create_new_age:overcharged_diamond')
    
    e.replaceInput({mod:'mekanism'}, '#forge:ingots/steel', 'powah:steel_energized')
    e.replaceInput({mod:'mekanism'}, '#forge:ingots/lead', '#forge:ingots/conductive_alloy')


    e.replaceInput({mod:'mekanismgenerators'}, 'minecraft:copper_ingot', 'nwtc:alumite_ingot')
    e.replaceInput({mod:'mekanismgenerators'}, 'minecraft:iron_ingot', 'nwtc:red_aurum_ingot')
    e.replaceInput({mod:'mekanismgenerators'}, 'minecraft:redstone', '#immersiveengineering:circuits/pcb')
    e.replaceInput({mod:'mekanismgenerators'}, 'minecraft:glowstone_dust', 'enderio:clayed_glowstone')
    e.replaceInput({mod:'mekanismgenerators'}, 'minecraft:diamond', 'create_new_age:overcharged_diamond')
    
    e.replaceInput({mod:'mekanismgenerators'}, '#forge:ingots/steel', 'powah:steel_energized')
    e.replaceInput({mod:'mekanismgenerators'}, '#forge:ingots/lead', '#forge:ingots/conductive_alloy')


    e.replaceInput({mod:'mekanism'}, 'minecraft:lapis_lazuli', 'mekanism:hdpe_sheet')
    e.replaceInput({mod:'mekanism'}, '#forge:ingots/lead', '#forge:ingots/conductive_alloy')


    
  
    //纸箱
    e.shapeless('mekanism:cardboard_box', 
    [ 
    '4x createdieselgenerators:wood_chip',
    ])
    //钢制机壳
    e.remove({ output: 'mekanism:steel_casing'})
    e.custom(
        {
            "type": "forbidden_arcanus:apply_modifier",
            "template": {
              "item": "forbidden_arcanus:darkstone_upgrade_smithing_template"
            },
            "addition": {
              "item": "mekanism:steel_casing"
            },
            "modifier": "forbidden_arcanus:magnetized"
        }
    )
    //冶金灌注机
    e.remove({ output: 'mekanism:metallurgic_infuser'})
    e.shaped('mekanism:metallurgic_infuser',[
      'UEU', 
      'ECE', 
      'UEU'
     ], {
       U: '#forge:plates/steel',
       E: 'nwtc:red_aurum_ingot',
       C: 'mekanism:steel_casing'
     })


    //灌注合金
    e.remove({ output: 'mekanism:alloy_infused',type:"mekanism:metallurgic_infusing"})
    //
    e.remove({ output: 'mekanism:basic_universal_cable'})
    e.shapeless('mekanism:basic_universal_cable', 
    [ 
      'powah:energy_cable_niotic',
      '4x mekanism:alloy_infused'
    ])
    e.remove({ output: 'mekanism:basic_pressurized_tube'})
    e.shapeless('mekanism:basic_pressurized_tube', 
    [ 
      'enderio:ender_fluid_conduit',
      '4x mekanism:alloy_infused'
    ])
    e.remove({ output: 'mekanism:basic_logistical_transporter'})
    e.shapeless('mekanism:basic_logistical_transporter', 
    [ 
      'enderio:item_conduit',
      '4x mekanism:alloy_infused'
    ])
    //能量立方
    e.remove({ output: 'mekanism:basic_energy_cube'})
    e.shapeless('mekanism:basic_energy_cube', 
    [ 
      'enderio:vibrant_capacitor_bank',
      '2x mekanism:energy_tablet'
    ])
    //疏导外壳
    e.remove({ output: 'mekanism:induction_casing'})
    e.shapeless('8x mekanism:induction_casing', 
    [ 
      'mekanism:steel_casing',
      '2x mekanism:hdpe_sheet',
      '2x mekanism:energy_tablet'
    ])
    e.remove({ output: 'mekanism:structural_glass'})
    e.shapeless('8x mekanism:structural_glass', 
    [ 
      '4x ae2:quartz_vibrant_glass',
      '2x nwtc:bismuth_ingot'
    ])
    //疏导端口
    e.remove({ output: 'mekanism:induction_port'})
    e.shapeless('2x mekanism:induction_port', 
    [ 
      'mekanism:steel_casing',
      '2x mekanism:ultimate_control_circuit',
      '2x mekanism:induction_casing'
    ])
    //疏导元件
    e.remove({ output: 'mekanism:basic_induction_cell'})
    e.shaped('mekanism:basic_induction_cell',[
      'UEU', 
      'ECE', 
      'UEU'
     ], {
       U: 'mekanism:induction_casing',
       E: 'mekanism:dust_lithium',
       C: 'mekanism:ultimate_energy_cube'
    })
    e.remove({ output: 'mekanism:advanced_induction_cell'})
    e.shaped('mekanism:advanced_induction_cell',[
    'UEU', 
    'ECE', 
    'UEU'
     ], {
     U: 'mekanism:induction_casing',
     E: 'mekanism:basic_induction_cell',
     C: 'mekanism:ultimate_energy_cube'
    })  
    e.remove({ output: 'mekanism:elite_induction_cell'})
    e.shaped('mekanism:elite_induction_cell',[
      'UEU', 
      'ECE', 
      'UEU'
     ], {
       U: 'mekanism:advanced_induction_cell',
       E: 'mekanism:dust_lithium',
       C: 'mekanism:ultimate_energy_cube'
    })
    e.remove({ output: 'mekanism:ultimate_induction_cell'})
    e.shaped('mekanism:ultimate_induction_cell',[
      'UEU', 
      'ECE', 
      'UEU'
     ], {
       U: 'mekanism:elite_induction_cell',
       E: 'mekanism:dust_lithium',
       C: 'mekanism:ultimate_energy_cube'
    })
    //涡轮外壳
    e.remove({ output: 'mekanismgenerators:turbine_casing'})
    e.shaped('8x mekanismgenerators:turbine_casing',[
      'UEU', 
      'ECE', 
      'UEU'
     ], {
       U: 'nwtc:bismuth_ingot',
       E: 'mekanism:hdpe_sheet',
       C: 'mekanism:steel_casing'
    })
    //裂变外壳
    e.remove({ output: 'mekanismgenerators:fission_reactor_casing'})
    e.shaped('16x mekanismgenerators:fission_reactor_casing',[
      'UEU', 
      'ECE', 
      'UEU'
     ], {
       U: 'nwtc:energy_superconductivity_ingot',
       E: 'mekanism:hdpe_sheet',
       C: 'mekanism:steel_casing'
    })
    


    //控制电路
    e.remove({ output: 'mekanism:advanced_control_circuit'})
    e.remove({ output: 'mekanism:elite_control_circuit'})
    e.remove({ output: 'mekanism:ultimate_control_circuit'})
    e.custom(
        {
        "type":"immersiveengineering:blueprint",
        "category":"electrode",
        "inputs":[{"base_ingredient":{"item":"mekanism:basic_control_circuit"},"count":2},
        {"base_ingredient":{"item":"mekanism:alloy_infused"},"count":4},
        {"base_ingredient":{"item":"ae2:printed_logic_processor"},"count":1},
        ],
        "result":{"item":"mekanism:advanced_control_circuit","count":4}
        }  
    )
    e.custom(
      {
      "type":"immersiveengineering:blueprint",
      "category":"electrode",
      "inputs":[{"base_ingredient":{"item":"mekanism:advanced_control_circuit"},"count":2},
      {"base_ingredient":{"item":"mekanism:alloy_reinforced"},"count":4},
      {"base_ingredient":{"item":"ae2:printed_engineering_processor"},"count":1},
      ],
      "result":{"item":"mekanism:elite_control_circuit","count":4}
      }  
    )
    e.custom(
      {
      "type":"immersiveengineering:blueprint",
      "category":"electrode",
      "inputs":[{"base_ingredient":{"item":"mekanism:elite_control_circuit"},"count":2},
      {"base_ingredient":{"item":"mekanism:alloy_atomic"},"count":4},
      {"base_ingredient":{"item":"megacells:printed_accumulation_processor"},"count":1},
      ],
      "result":{"item":"mekanism:ultimate_control_circuit","count":4}
      }  
    )
  


  
  })
 